<template>
  <div>
    <mt-page-title>
      <h1 class="has-text-weight-bold is-size-3">Liste des organismes</h1>
    </mt-page-title>
    <div class="columns is-vcentered mt-marginless-bottom">
      <div class="column">
        <span class="has-text-weight-bold has-text-grey is-size-5"
          >{{ nbTotal }} organismes ({{ nbBrigade }} brigades - {{ nbRegiment }} régiments - {{ nbUnite }} unités)</span
        >
      </div>
    </div>
    <div class="columns is-vcentered mt-marginless-bottom">
      <div class="column">
        <b-autocomplete
          v-model="stringSearch"
          rounded
          :data="filteredOrganismeArray"
          placeholder="Rechercher..."
          icon="magnify"
          field="code"
          clearable
          @select="(option) => openTree(option)"
        >
          <template #empty>Aucun résultat</template>
          <template slot-scope="org">
            <div class="columns">
              <div class="column  is-2">
                {{ org.option.code }}
              </div>
              <div class="column">
                {{ org.option.libelle }}
              </div>
              <div class="column is-2">
                {{ org.option.libelleTypeOrganisme }}
              </div>
            </div>
          </template>
        </b-autocomplete>
      </div>
      <div class="column is-narrow">
        <b-button
          v-if="isAdmin"
          class="has-text-weight-semibold"
          type="is-primary"
          icon-left="plus"
          @click="ajouterBrigade"
          >Ajouter une brigade</b-button
        >
      </div>
    </div>
    <div>
      <b-button class="has-text-weight-semibold" type="is-primary" icon-left="home-plus" @click="toutDeplier"
        >Tout déplier</b-button
      >
      <b-button class="has-text-weight-semibold" type="is-primary" icon-left="home-minus" @click="toutReplier"
        >Tout replier</b-button
      >
    </div>
    <div>
      <tree-item
        v-for="(child, index) in organismes"
        :key="index"
        class="item"
        :organisme="child"
        @confirmer-supprimer="confirmerSupprimer"
        @add-regiment="ajouterRegiment"
        @add-unite="ajouterUnite"
        @edit="editOrganisme"
      ></tree-item>
    </div>
    <mt-modal-action type-delete :ouvert.sync="ouvertDelete" @action="supprimerOrganisme(monOrganisme)">
      Êtes-vous certain(e) de vouloir supprimer l'organisme ?
    </mt-modal-action>
    <mt-modal :ouvert.sync="ouvertEdit">
      <form @submit.prevent="modifier">
        <mt-champs-form-organisme :organisme="organisme" />
        <div class="columns is-centered">
          <p class="control">
            <b-button class="is-primary has-text-weight-semibold" type="is-primary" native-type="submit">
              Modifier l'organisme
            </b-button>
          </p>
        </div>
      </form>
    </mt-modal>
    <mt-modal :ouvert.sync="ouvertAdd">
      <form @submit.prevent="submit">
        <mt-champs-form-organisme :organisme="organisme" />
        <div class="columns is-centered">
          <p class="control">
            <b-button class="is-primary has-text-weight-semibold" type="is-primary" native-type="submit">
              Créer l'organisme
            </b-button>
          </p>
        </div>
      </form>
    </mt-modal>
  </div>
</template>
<script>
import treeItem from '~/components/dashboard/organisme/tree-organisme';
import MtPageTitle from '~/components/base/page-title/index';
import MtModal from '~/components/modal/mt-modal';
import MtModalAction from '~/components/modal/mt-modal-action';
import MtChampsFormOrganisme from '~/components/dashboard/organisme/champs-organisme';
import newOrganisme from '~/components/mixins/organismeMixin';
import tokenMixin from '~/components/mixins/tokenMixin';

export default {
  layout: 'dashboard',
  components: {
    treeItem,
    MtPageTitle,
    MtModalAction,
    MtModal,
    MtChampsFormOrganisme,
  },
  mixins: [tokenMixin],
  computed: {
    filteredOrganismeArray() {
      const organismesRet = [];
      this.organismes.forEach((brigade) => {
        if (this.estRecherche(brigade)) {
          organismesRet.push(brigade);
        }
        brigade.organismesEnfants.forEach((regiment) => {
          if (this.estRecherche(regiment)) {
            organismesRet.push(regiment);
          }
          regiment.organismesEnfants.forEach((unite) => {
            if (this.estRecherche(unite)) {
              organismesRet.push(unite);
            }
          });
        });
      });
      return organismesRet;
    },
  },
  async asyncData({ $api, store }) {
    const organismes = await $api.organismes.allHiearchie();
    const isAdmin = store.getters['context/isAdmin'];
    let nbBrigade = 0;
    let nbRegiment = 0;
    let nbUnite = 0;
    organismes.forEach((brigade) => {
      nbBrigade += 1;
      brigade.organismesEnfants.forEach((regiment) => {
        nbRegiment += 1;
        regiment.organismesEnfants.forEach(() => {
          nbUnite += 1;
        });
      });
    });
    const nbTotal = nbBrigade + nbRegiment + nbUnite;
    return {
      organismes,
      ouvertDelete: false,
      ouvertAdd: false,
      ouvertEdit: false,
      monOrganisme: null,
      organisme: null,
      stringSearch: '',
      nbBrigade,
      nbRegiment,
      nbUnite,
      nbTotal,
      isAdmin,
    };
  },
  methods: {
    estRecherche(organisme) {
      return (
        organisme.code
          .toString()
          .toLowerCase()
          .includes(this.stringSearch.toLowerCase()) ||
        organisme.libelle
          .toString()
          .toLowerCase()
          .includes(this.stringSearch.toLowerCase())
      );
    },
    async submit() {
      try {
        const { organisme, token } = await this.$api.organismes.post(this.organisme);
        this.organisme = organisme;
        this.setToken(token);
        this.$store.dispatch('context/setOrganismes', await this.$api.organismes.affectableAllowed());
        this.organismes = await this.$api.organismes.allHiearchie();
        this.openTree(this.organisme);
        this.compterOrganismes();
        this.ouvertAdd = false;
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
    async modifier() {
      try {
        this.organisme = await this.$api.organismes.put(this.organisme.id, this.organisme);
        const organismeSelected = this.$store.getters['context/organisme'];
        const organismes = await this.$api.organismes.affectableAllowed();
        this.$store.dispatch('context/setOrganismes', organismes);
        let index = 0;
        for (let i = 0; i < organismes.length; i += 1) {
          if (organismes[i].id === organismeSelected.id) {
            index = i;
            break;
          }
        }
        this.$store.dispatch('context/setOrganisme', organismes[index]);
        this.organismes = await this.$api.organismes.allHiearchie();
        this.openTree(this.organisme);
        this.ouvertEdit = false;
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
    ajouterBrigade() {
      const typeOrg = this.appTypesOrganismes.find((type) => type.code === 'brigade');
      const idType = typeOrg.id;
      this.organisme = Object.assign(newOrganisme(), { idparent: null, idTypeOrganisme: idType });
      this.ouvertAdd = true;
    },
    ajouterRegiment(value) {
      const typeOrg = this.appTypesOrganismes.find((type) => type.code === 'regiment');
      const idType = typeOrg.id;
      this.organisme = Object.assign(newOrganisme(), { idparent: value.id, idTypeOrganisme: idType });
      this.ouvertAdd = true;
    },
    ajouterUnite(value) {
      const typeOrg = this.appTypesOrganismes.find((type) => type.code === 'unite');
      const idType = typeOrg.id;
      this.organisme = Object.assign(newOrganisme(), { idparent: value.id, idTypeOrganisme: idType });
      this.ouvertAdd = true;
    },
    editOrganisme(value) {
      this.organisme = Object.assign(newOrganisme(), value);
      this.ouvertEdit = true;
    },
    confirmerSupprimer(value) {
      this.ouvertDelete = true;
      this.monOrganisme = value;
    },
    async supprimerOrganisme(organisme) {
      try {
        await this.$api.organismes.delete(organisme.id);
        let organismeSelected = this.$store.getters['context/organisme'];
        if (organismeSelected.id === organisme.id) {
          organismeSelected = this.$store.state.auth.user.affectation.organisme;
        }
        const organismes = await this.$api.organismes.affectableAllowed();
        this.$store.dispatch('context/setOrganismes', organismes);
        let index = 0;
        for (let i = 0; i < organismes.length; i += 1) {
          if (organismes[i].id === organismeSelected.id) {
            index = i;
            break;
          }
        }
        this.$store.dispatch('context/setOrganisme', organismes[index]);
        this.organismes = await this.$api.organismes.allHiearchie();
        this.compterOrganismes();
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
    openTree(organisme) {
      if (organisme !== null) {
        this.toutReplier();
        if (organisme.id) {
          this.organismes.forEach((brigade) => {
            if (brigade.id === organisme.id) {
              // eslint-disable-next-line no-param-reassign
              brigade.selected = true;
            }
            brigade.organismesEnfants.forEach((regiment) => {
              if (regiment.id === organisme.id) {
                // eslint-disable-next-line no-param-reassign
                brigade.isOpen = true;
                // eslint-disable-next-line no-param-reassign
                regiment.selected = true;
              }
              regiment.organismesEnfants.forEach((unite) => {
                if (unite.id === organisme.id) {
                  // eslint-disable-next-line no-param-reassign
                  brigade.isOpen = true;
                  // eslint-disable-next-line no-param-reassign
                  regiment.isOpen = true;
                  // eslint-disable-next-line no-param-reassign
                  unite.selected = true;
                }
              });
            });
          });
        }
      }
    },
    toutDeplier() {
      this.organismes.forEach((brigade) => {
        // eslint-disable-next-line no-param-reassign
        brigade.isOpen = true;
        // eslint-disable-next-line no-param-reassign
        brigade.selected = false;
        brigade.organismesEnfants.forEach((regiment) => {
          // eslint-disable-next-line no-param-reassign
          regiment.isOpen = true;
          // eslint-disable-next-line no-param-reassign
          regiment.selected = false;
          regiment.organismesEnfants.forEach((unite) => {
            // eslint-disable-next-line no-param-reassign
            unite.isOpen = true;
            // eslint-disable-next-line no-param-reassign
            unite.selected = false;
          });
        });
      });
    },
    toutReplier() {
      this.organismes.forEach((brigade) => {
        // eslint-disable-next-line no-param-reassign
        brigade.isOpen = false;
        // eslint-disable-next-line no-param-reassign
        brigade.selected = false;
        brigade.organismesEnfants.forEach((regiment) => {
          // eslint-disable-next-line no-param-reassign
          regiment.isOpen = false;
          // eslint-disable-next-line no-param-reassign
          regiment.selected = false;
          regiment.organismesEnfants.forEach((unite) => {
            // eslint-disable-next-line no-param-reassign
            unite.isOpen = false;
            // eslint-disable-next-line no-param-reassign
            unite.selected = false;
          });
        });
      });
    },
    compterOrganismes() {
      let nbBrigade = 0;
      let nbRegiment = 0;
      let nbUunite = 0;
      this.organismes.forEach((brigade) => {
        nbBrigade += 1;
        brigade.organismesEnfants.forEach((regiment) => {
          nbRegiment += 1;
          regiment.organismesEnfants.forEach(() => {
            nbUunite += 1;
          });
        });
      });
      this.nbBrigade = nbBrigade;
      this.nbRegiment = nbRegiment;
      this.nbUunite = nbUunite;
      this.nbTotal = nbBrigade + nbRegiment + nbUunite;
    },
  },
};
</script>
<style scoped lang="scss"></style>
